routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\CommentController;
use App\Http\Controllers\DiscussionController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [DiscussionController::class, 'index'])->name('home');


//============================Routes for discussions middleware in controller constructor
Route::resource('discussions', DiscussionController::class);

//============================Routes for approving
Route::middleware('adminApprove')->group(function () {
    Route::get('/approve', [DiscussionController::class, 'notApproved'])->name('discussions.notapproved');
    Route::get('/notapproved', [DiscussionController::class, 'renderNotApproved']);
    Route::get('/approved', [DiscussionController::class, 'renderApproved'])->name('discussions.approve');


    Route::put('/approve/{discussion}', [DiscussionController::class, 'approve'])->name('approve.store');
});

//============================Routes for comments 
Route::resource('comments', CommentController::class)->middleware('auth');
Route::get('/comments/create/{discussion}', [CommentController::class, 'create'])->name('comments.createCustom')->middleware('auth');

require __DIR__ . '/auth.php';

app/Models/Discussion.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Discussion extends Model
{
    use HasFactory;

    protected $guarded = [];

    public function category()
    {
        return $this->belongsTo(Category::class);
    }

    public function user()
    {
        return $this->belongsTo(User::class);
    }

    public function comments()
    {
        return $this->hasMany(Comment::class)->with('user');
    }
}

app/Http/Controllers/DiscussionController.php
<?php

namespace App\Http\Controllers;

use App\Models\Category;
use App\Models\Discussion;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\File;
use App\Http\Requests\DiscussionRequest;

class DiscussionController extends Controller
{

    public function __construct()
    {
        $this->middleware('auth')->except('index', 'show');
        $this->middleware('adminApprove')->only('edit', 'update', 'destroy');
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $discussions = Discussion::where('is_approved', 1)->with('category', 'user')->paginate(5);
        return view('home', compact('discussions'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $categories = Category::all();
        return view('discussions.create', compact('categories'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(DiscussionRequest $request)
    {

        $discussion = new Discussion();
        $discussion->title = $request->title;
        $discussion->description = $request->description;
        $discussion->category_id = $request->category_id;
        $discussion->user_id = Auth::id();

        if (Auth::user()->isAdmin()) $discussion->is_approved = 1;

        if ($request->image) {
            $imageName = time() . '.' . $request->image->extension();
            $request->image->move(public_path('images/discussions'), $imageName);
            $discussion->image = "/images/discussions/{$imageName}";
        }

        if (!$discussion->save()) return redirect()->route('discussions.create')->with('error', 'Discussion could not be created!');

        $message = 'Discussion successfuly created! It needs to be approved before you dig into it though!';

        if (Auth::user()->isAdmin()) $message = 'Discussion successfuly created! Its approved since you are an admin!';

        return redirect()->route('home')->with('success', $message);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show(Discussion $discussion)
    {
        if ((Auth::user() && Auth::user()->isAdmin()) || $discussion->is_approved) return view('discussions.show', compact('discussion'));

        return abort(404);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit(Discussion $discussion)
    {
        $categories = Category::all();
        return view('discussions.edit', compact('discussion', 'categories'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(DiscussionRequest $request, Discussion $discussion)
    {

        if ($request->image) {
            $imageName = time() . '.' . $request->image->extension();
            $request->image->move(public_path('images/discussions'), $imageName);
            $discussion->image = "/images/discussions/{$imageName}";
            $imagePath = "/images/discussions/{$imageName}";
            $oldImagePath = public_path($request->currentImage);

            if (File::exists($oldImagePath))  File::delete($oldImagePath);
        } else {
            $imagePath = $request->currentImage;
        }

        $discussion->title = $request->title;
        $discussion->description = $request->description;
        $discussion->category_id = $request->category_id;
        ($request->is_approved) ? $discussion->is_approved = 1 : $discussion->is_approved = 0;
        $discussion->image = $imagePath;

        if (!$discussion->save()) return redirect()->route('discussions.edit', $discussion->id)->with('error', 'Discussion could not be edited!');

        return redirect()->route('discussions.edit', $discussion->id)->with('success', 'Discussion edited successfuly!');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy(Discussion $discussion)
    {
        $image = public_path($discussion->image);

        if (!$discussion->delete())  return response()->json(['status' => 400, 'message' => 'Error',]);

        if (File::exists($image)) File::delete($image);

        return response()->json(['status' => 200, 'message' => 'Success',]);
    }

    //rendering via AJAX

    public function notApproved()
    {
        $discussions = Discussion::where('is_approved', 0)->with('category', 'user')->paginate(5);
        return view('discussions.approve', compact('discussions'));
    }

    public function renderNotApproved()
    {
        $discussions = Discussion::where('is_approved', 0)->with('category', 'user')->paginate(5);
        $approved = false;
        return view('layouts.discussions', compact('discussions', 'approved'))->render();
    }

    public function renderApproved()
    {
        $discussions = Discussion::where('is_approved', 1)->with('category', 'user')->paginate(5);
        $approved = true;
        return view('layouts.discussions', compact('discussions', 'approved'))->render();
    }

    // updating via AJAX

    public function approve(Request $request, Discussion $discussion)
    {
        $discussion->is_approved = 1;

        if (!$discussion->save()) return response()->json(['status' => 400, 'message' => 'Error',]);

        return response()->json(['status' => 200, 'message' => 'Success',]);
    }
}

app/View/Components/AppLayout.php
<?php

namespace App\View\Components;

use Illuminate\View\Component;

class AppLayout extends Component
{
    /**
     * Get the view / contents that represents the component.
     *
     * @return \Illuminate\View\View
     */
    public function render()
    {
        return view('layouts.app');
    }
}

resources/views/discussions/approve.blade.php
<x-app-layout>
    <x-slot name="header">
        
        @include('layouts.sessionAlert')

        <h2 class="font-semibold text-4xl text-gray-800 leading-tight text-center">
            {{ __('Welcome to the forum') }}
        </h2>
    </x-slot>

    
    @include('layouts.backButton', ['route'=>'home'])

    
    
    <div class="py-3">
        <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
                
            <button class="h-10  bg-white tracking-wide text-gray-800 font-bold rounded border-b-2  hover:border-blue-600 hover:bg-blue-500 hover:text-white shadow-md py-2 px-6 inline-flex items-center" id='approvedFilter' types='button'>Approved</button>
            <button class="h-10  bg-white tracking-wide text-gray-800 font-bold rounded border-b-2 border-red-500 hover:border-red-600 hover:bg-red-500 hover:text-white shadow-md py-2 px-6 inline-flex items-center" id='notapprovedFilter' types='button'>Not Approved</button>
            
        </div>
    </div>
    
    <div id="discussions">
        @include('layouts.discussions')        
    </div>      
   
   
</x-app-layout>

resources/views/discussions/create.blade.php
<x-app-layout>
    <x-slot name="header">
        <h2 class="font-semibold text-4xl text-gray-800 leading-tight text-center">
            {{ __('Add a new discussion') }}
        </h2>
    </x-slot>

    
    @include('layouts.sessionAlert')

    @include('layouts.backButton', ['route'=>'discussions.index'])

    <div class="py-12">
        <div class="w-full max-w-lg mx-auto sm:px-6 lg:px-8">
            <div class="bg-white overflow-hidden shadow-sm sm:rounded-lg">
                <div class="p-6 bg-white border-b border-gray-200">
                    <form class="w-full max-w-lg" method="POST" enctype="multipart/form-data" action="{{ route('discussions.store') }}">
                        @csrf
            
                        @php
                            $errorClasses = ' border-rose-500';

                            $titleError = $errors->has('title') ? $errorClasses : '';
                            $imageError = $errors->has('image') ? $errorClasses : '';
                            $descriptionError = $errors->has('description') ? $errorClasses : '';
                            $categoryError = $errors->has('category') ? $errorClasses : '';
                        @endphp
            
                        <!-- Title -->
                        <div>
                            <x-label for="title" :value="__('Title')" />
                            <x-input class="w-full mt-1 {{ $titleError }}" id="title" type="text" name="title" :value="old('title')"/>
                        </div>
            
                        @error('title')
                            <span class="text-red-500 text-xs italic" role="alert">
                                {{ $message }}
                            </span>
                        @enderror
            
                        <!-- Image -->
                       
                        <div class="flex flex-wrap -mx-3 mt-4">
                            <div class="w-full px-3">
                              <label class="block tracking-wide text-gray-700 text-sm border-gray-300 font-medium" for="image">
                                Image
                              </label>                       
                          
                              
                              <input class="mt-1 block w-full rounded-md shadow-sm py-2 px-3 border border-gray-300 focus:border-indigo-300 focus:ring focus:ring-indigo-200 focus:ring-opacity-50 {{ $imageError }}" type="file" name="image" id="image">
                            </div>
                        </div>
   
                        @error('image')
                            <span class="text-red-500 text-xs italic" role="alert">
                                {{ $message }}
                            </span>
                        @enderror

                        <!-- Description -->
  
                        <div class="mt-4">
                        <x-label for="description" :value="__('Description')" />
                        <textarea name="description" id="description" class="mt-1 block w-full rounded-md shadow-sm py-2 px-3 border-gray-300 focus:border-indigo-300 focus:ring focus:ring-indigo-200 focus:ring-opacity-50 {{ $descriptionError }}">{{old('description')}} </textarea>
                        </div>

                        @error('description')
                            <span class="text-red-500 text-xs italic" role="alert">
                                {{ $message }}
                            </span>
                        @enderror
                        <!-- Category -->

                        <div class="mt-4">
                            <x-label for="category" :value="__('Category')" />
                            <select id="categorySelect" class="mt-1 block w-full rounded-md shadow-sm py-2 px-3 border-gray-300 focus:border-indigo-300 focus:ring focus:ring-indigo-200 focus:ring-opacity-50 {{ $categoryError }}" name="category_id" id="category_id">
                                @isset($categories)
                                    @foreach ($categories as $category )
                                        <option value="{{$category->id}}" @if($category->id == old('category_id')) selected @endif>{{$category->name}}</option>
                                    @endforeach                                
                                @endisset            
                            </select>
                        </div>
                        @error('category_id')
                            <span class="text-red-500 text-xs italic" role="alert">
                                {{ $message }}
                            </span>
                        @enderror

                        <!--Submit-->
                        <div class="flex items-center mt-4">                                      
                            <x-button class="bg-blue-400 hover:bg-blue-700">
                                {{ __('Submit') }}
                            </x-button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>

   
</x-app-layout>

resources/views/discussions/edit.blade.php
<x-app-layout>
    <x-slot name="header">
        <h2 class="font-semibold text-4xl text-gray-800 leading-tight text-center">
            {{ __('Edit discussion') }}
        </h2>
    </x-slot>

    
    @include('layouts.sessionAlert')

    @include('layouts.backButton', ['route'=>'discussions.notapproved' ])

    <div class="pb-12">
        <div class="w-full max-w-lg mx-auto sm:px-6 lg:px-8">
            <div class="bg-white overflow-hidden shadow-sm sm:rounded-lg">
                <div class="p-6 bg-white border-b border-gray-200">
                    <form class="w-full max-w-lg" method="POST" enctype="multipart/form-data" action="{{ route('discussions.update', $discussion->id) }}">
                        @csrf
                        @method('PUT')
                        @php
                            $errorClasses = ' border-rose-500';

                            $titleError = $errors->has('title') ? $errorClasses : '';
                            $imageError = $errors->has('image') ? $errorClasses : '';
                            $descriptionError = $errors->has('description') ? $errorClasses : '';
                            $categoryError = $errors->has('category') ? $errorClasses : '';
                        @endphp
            
                        <!-- Title -->
                        <div>
                            <x-label for="title" :value="__('Title')" />
                            <x-input class="w-full mt-1 {{ $titleError }}" id="title" type="text" name="title" value="{{ $discussion->title }}"/>
                        </div>
            
                        @error('title')
                            <span class="text-red-500 text-xs italic" role="alert">
                                {{ $message }}
                            </span>
                        @enderror

                        <input type="hidden" name="currentImage" value="{{ $discussion->image }}">

                        <div class="md:shrink-0 flex items-center justify-center pt-5">
                            <img class="h-48 w-full object-cover md:w-48" src="{{ $discussion->image }}" alt="discussionImage">   
                        </div>
            
                        <!-- Image -->

                        <div class="flex flex-wrap -mx-3 mt-4">
                            <div class="w-full px-3">
                              <label class="block tracking-wide text-gray-700 text-sm border-gray-300 font-medium" for="image">
                                New Image
                              </label>                       
                          
                              
                              <input class="mt-1 block w-full rounded-md shadow-sm py-2 px-3 border border-gray-300 focus:border-indigo-300 focus:ring focus:ring-indigo-200 focus:ring-opacity-50 {{ $imageError }}" type="file" name="image" id="image">
                            </div>
                        </div>
   
                        @error('image')
                            <span class="text-red-500 text-xs italic" role="alert">
                                {{ $message }}
                            </span>
                        @enderror


                        <!-- Approved -->

                        <div class="flex justify-center mt-4">
                            <label class="inline-flex items-center">
                                <input type="checkbox" name="is_approved" class="form-checkbox" @if($discussion->is_approved == 1) checked  @endif>
                                <span class="ml-2">Approved</span>
                            </label>
                        </div>
                        

                        <!-- Description -->

                        <div class="mt-4">
                        <x-label for="description" :value="__('Description')" />
                        <textarea name="description" id="description" class="mt-1 block w-full rounded-md shadow-sm py-2 px-3 border-gray-300 focus:border-indigo-300 focus:ring focus:ring-indigo-200 focus:ring-opacity-50 {{ $descriptionError }}">{{ $discussion->description }} </textarea>
                        </div>

                        @error('description')
                            <span class="text-red-500 text-xs italic" role="alert">
                                {{ $message }}
                            </span>
                        @enderror
                        <!-- Category -->

                        <div class="mt-4">
                            <x-label for="category" :value="__('Category')" />
                            <select id="categorySelect" class="mt-1 block w-full rounded-md shadow-sm py-2 px-3 border-gray-300 focus:border-indigo-300 focus:ring focus:ring-indigo-200 focus:ring-opacity-50 {{ $categoryError }}" name="category_id" id="category_id">
                                @isset($categories)
                                    @foreach ($categories as $category )
                                        <option value="{{$category->id}}" @if($category->id == $discussion->category_id) selected @endif>{{$category->name}}</option>
                                    @endforeach                                
                                @endisset            
                            </select>
                        </div>
                        @error('category_id')
                            <span class="text-red-500 text-xs italic" role="alert">
                                {{ $message }}
                            </span>
                        @enderror

                        <!--Submit-->
                        <div class="flex items-center mt-4">                                      
                            <x-button class="bg-blue-400 hover:bg-blue-700">
                                {{ __('Update') }}
                            </x-button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>

   
</x-app-layout>

resources/views/discussions/show.blade.php
<x-app-layout>
    <x-slot name="header">

        @include('layouts.sessionAlert')
        
        <h2 class="font-semibold text-4xl text-gray-800 leading-tight text-center">
            {{ __('Welcome to the forum') }}
        </h2>
    </x-slot>
    
    @isset($discussion)       
        <div class="py-3">
            <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
                <div class="bg-white overflow-hidden shadow-sm sm:rounded-lg">
                    <div class="p-6 bg-white border-b border-gray-200">
                        <div class="ml-auto flex items- justify-between text-sm text-gray-500">      
                            <div>
                                @include('layouts.backButton', ['route'=>'discussions.index'])
                            </div>                       
                            <span>{{ $discussion->category->name }} | {{ $discussion->user->username }}</span>
                        </div>

                        <div class="md:shrink-0 flex items-center justify-center p-12 flex-col">
                                <img class="w-3/4 object-cover" src="{{ $discussion->image }}" alt="discussionImage">
                        </div>
                        
                        <div class="lg:px-48"> 
                            <h4 class="text-3xl font-semibold">
                                {{ $discussion->title }}
                            </h4>
                            <p> {{ $discussion->description }} </p>
                        </div>                       
                    </div>
                </div>
            </div>
        </div>     
    @endisset

    
    <div class="py-5">
        <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
            <h4 class="text-3xl font-semibold">
                Comments :
            </h4>
        </div>
    </div>

    <div class="py-5">
        <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
            @if(Auth::check())
            <a id="show_comment_create" class="py-2 px-6 font-semibold rounded-md bg-gray-500 hover:bg-gray-700 text-white" href="{{ route('comments.store') }}">Comment</a>
            @else
            <a class="py-2 px-6 font-semibold rounded-md bg-gray-500 hover:bg-gray-700 text-white" href="{{ route('comments.createCustom', $discussion->id)}}">Comment</a>
            @endauth
            
        </div>
    </div>

    {{-- @if (!$discussion->comments->isEmpty())         --}}
    <div id="comments">
        @foreach ($discussion->comments as $comment)
            @include('layouts.comment', $comment)        
        @endforeach
    </div>
    {{-- @endif --}}
   
</x-app-layout>